#define INCL_DOS
#define INCL_WIN
#include <os2.h>


#include <stdio.h>
#include <stdlib.h>

int main()
{
    HAB hab;
    HMQ hmq;
    QMSG qmsg;
    APIRET rc;
    HMODULE hmod;
    PFN LockupHook, DestroyWindowHook;
    PSZ dllname="LOCKHOOK.DLL";
    PTIB ptib;
    PPIB ppib;


    if(!DosQueryModuleHandle(dllname, &hmod))
    {
        printf("Already installed.\n");
        return 1;
    }
    if(!(hab=WinInitialize(0))) return 1;

    DosLoadModule(NULL, 0, dllname, &hmod);
    DosQueryProcAddr(hmod, 0, "LockupHook", &LockupHook);
    DosQueryProcAddr(hmod, 0, "DestroyWindowHook", &DestroyWindowHook);

    rc=WinSetHook(hab,                   /* Anchor block handle            */
                  0,                   /* Thread message queue           */
                  HK_LOCKUP,              /* Called by the input hook       */
                  (PFN) LockupHook,     /* Address of input-hook function */
                  hmod);        /* Function is in appl. module    */
    if(!rc)
    {
        printf("Error setting hook!\n");
        return 1;
    }

    rc=WinSetHook(hab,                   /* Anchor block handle            */
                  0,                   /* Thread message queue           */
                  HK_DESTROYWINDOW,              /* Called by the input hook       */
                  (PFN) DestroyWindowHook,     /* Address of input-hook function */
                  hmod);        /* Function is in appl. module    */

    if(!rc)
    {
        printf("Error setting hook!\n");
        return 1;
    }


    while(1)DosSleep(10000);


    DosFreeModule(hmod);
    WinTerminate(hab);
    return 0;
}
